class Limit {
	id = 0;
	success = false;
	text = null;
	paxRequired = GSController.GetSetting("min_transport_pax");
	mailRequired = GSController.GetSetting("min_transport_mail");

	constructor (t_id) {
		this.id = t_id;
	}

	function LimitTown() {
	
		// if the size of the town is below the threshold, set the growth rate to normal
		local threashold_setting = GSController.GetSetting("town_size_threshold");
		local townPopulation = GSTown.GetPopulation(this.id);
		if (townPopulation <= threashold_setting) {
			this.success = true;
			this.text = GSText(GSText.STR_TOO_SMALL);
			return;
		}

		else if (paxRequired && mailRequired) {
			local text1 = null;
			local text2 = null;
		
			local paxTransport = GSTown.GetLastMonthTransportedPercentage (this.id, Helper.GetPAXCargo());
			local mailTransport = GSTown.GetLastMonthTransportedPercentage (this.id, Helper.GetMailCargo());
			if (paxTransport < 0) paxTransport = 0;
			if (mailTransport < 0) mailTransport = 0;
			local PaxTooLow = paxTransport < this.paxRequired;
			local MailTooLow = mailTransport < this.mailRequired;

			if (PaxTooLow || MailTooLow) {
				this.success = false;
			} else {
				this.success = true;
			}
			
			text1 = PaxTooLow ?
				GSText(GSText.STR_PAX_BAD, paxTransport, this.paxRequired) :
				GSText(GSText.STR_PAX_GOOD, paxTransport, this.paxRequired);
			text2 = MailTooLow ?
				GSText(GSText.STR_MAIL_BAD, mailTransport, this.mailRequired) :
				GSText(GSText.STR_MAIL_GOOD, mailTransport, this.mailRequired);
			this.text = this.SetText(GSText(GSText.STR_2, text1, text2));
		}

		else if (paxRequired) {
			local paxTransport = GSTown.GetLastMonthTransportedPercentage (this.id, Helper.GetPAXCargo());
			if (paxTransport < 0) paxTransport = 0;
			local PaxTooLow = paxTransport < this.paxRequired;
			if (PaxTooLow) {
				this.text = GSText(GSText.STR_PAX_BAD, paxTransport, this.paxRequired);
				this.success = false;
			} else {
				this.text = GSText(GSText.STR_PAX_GOOD, paxTransport, this.paxRequired);
				this.success = true;
			}
		}

		else if (mailRequired) {
			local mailTransport = GSTown.GetLastMonthTransportedPercentage (this.id, Helper.GetMailCargo());
			if (mailTransport < 0) mailTransport = 0;
			local MailTooLow = mailTransport < this.mailRequired;
			if (MailTooLow) {
				this.text = GSText(GSText.STR_MAIL_BAD, mailTransport, this.mailRequired);
				this.success = false;
			} else {
				this.text = GSText(GSText.STR_MAIL_GOOD, mailTransport, this.mailRequired);
				this.success = true;
			}
		}
	}
}
